import pandas as pd
import json
import os
arr_json_data = []
 
token_add= '2ZoJVM15fbbDgo6s5cTTX2Sj8V4sJ47rimb7gQhGpump'
arr_store_keys = [
         "address",
        "sell_amount_cur",
        "buy_amount_cur",

        
        "buy_tx_count_cur",
        "sell_tx_count_cur",
        
        "profit",
        "realized_profit",
        "avg_cost",
        "avg_sold",
        "start_holding_at",
        "end_holding_at"
]
aar =   {
        "address": "EZZk361QgZDMx52AmMyc4NjFkuaNrdegwAxrLEbeaR94",
        "sell_amount_cur": 34148763.167781,        
        "buy_amount_cur": 34148763.167781,

        "buy_tx_count_cur": 9,
        "sell_tx_count_cur": 77,
        
        "profit": 4928.853565607387,
        "realized_profit": 4928.853565607387,
        "avg_cost": 0.000043969347937453594,
        "avg_sold": 0.00018887449941234176,
        "start_holding_at": 1742168061,
        "end_holding_at": 1742172930,
        "tags": [
            "sandwich_bot"
        ],
 
    } 
    
def get_handle_json_top_trader():

    global arr_file,token_add  , arr_json_data
    arr_file = []
 
    with open(f'top_trader_gmgn_{token_add}.json', 'r',encoding='utf8') as f:
        old_arr_json_data = json.load(f)
 
    
    for obj in old_arr_json_data:
        filtered_obj = {}
        # 遍历obj的每一个value 元素，如果元素是数组或者obj，就删除这个key，否则就保留这个key
        for key, value in obj.items():
            if isinstance(value, list) or isinstance(value, dict):
                continue
            else:
                if key in arr_store_keys:
                    filtered_obj[key] = value
                else:
                    continue
                
                
        arr_json_data.append(filtered_obj)
    
    return
                
import pytz
def utc_2_shanghaidate(df , utc_time_col ):
# 将字符串转换为UTC时间的datetime对象
    # df[utc_time_col] = pd.to_datetime(df[utc_time_col], utc=True)
    # 定义UTC+8时区
    utc_plus_8 = pytz.timezone('Asia/Shanghai')
    # 转换为UTC+8时间
    df[utc_time_col] = df[utc_time_col].dt.tz_localize('UTC')
    # # 提取时间字符串
    # df['shanghai_date'] = df['shanghai_date'].dt.strftime('%Y-%m-%d %H:%M')
    df[utc_time_col] = df[utc_time_col].dt.tz_convert(utc_plus_8)
    # 提取时间字符串
    df[utc_time_col] = df[utc_time_col].dt.strftime('%Y-%m-%d %H:%M')
    return df

 

def arr_json_2_df():
    global arr_json_data
    df  = pd.DataFrame(arr_json_data)
    # print(df)
    df['sell_token_amount'] = df['sell_amount_cur']  / 1e6
    df['buy_token_amount'] = df['buy_amount_cur']  / 1e6
    
    df['buy_tx_count'] = df['buy_tx_count_cur']  
    df['sell_tx_count'] = df['sell_tx_count_cur']  
    # 将价格转化为是市值 xxxK的市值
    df['avg_cost'] = df['avg_cost'] *( 1e3 * 1e6/1e3) 
    df['avg_sold'] = df['avg_sold'] *( 1e3 * 1e6 / 1e3)
    
    df['duration'] = (df['end_holding_at'] - df['start_holding_at'] )/60/60
    
    df["start_datetime"] = pd.to_datetime(df["start_holding_at"], unit='s'  )
    df = utc_2_shanghaidate(df, "start_datetime")

    df["end_datetime"] = pd.to_datetime(df["end_holding_at"], unit='s' )
    
    df = utc_2_shanghaidate(df, "end_datetime")
    df =df [[       "address",
        "buy_token_amount",
        "sell_token_amount",

        
        "buy_tx_count_cur",
        "sell_tx_count_cur",
        
        # "profit",
        "realized_profit",
        "avg_cost",
        "avg_sold",
        "start_datetime",
        "end_datetime" ,
        "duration"
        ]]
    
    df =df.sort_values(by=['realized_profit'], ascending=False)
    
 
    df.to_excel(f'top_trader_gmgn_{token_add}.xlsx',index=False)
 


get_handle_json_top_trader()
arr_json_2_df()